'
' ####################
' #####  PROLOG  #####
' ####################
'
' RDTSC - Read Time Stamp Counter 
' Returns the number of clock cycles since the CPU was powered up or reset.
' Can be used for benchmarking/timing.
' (rdtsc instruction is only available on Pentium CPUs)
'
' Also see the asm demo timestamp.x.
'
CONSOLE

'	IMPORT "xst"				' Standard library : required by most programs

DECLARE FUNCTION Entry ()

' rdtsc : mov [esp+4],eax : mov [esp+8],edx : ret 8
$$RDTSC = "\x0F\x31\x89\x44\x24\x04\x89\x54\x24\x08\xC2\x08"


FUNCTION Entry ()

	FUNCADDR RDTSC(GIANT)
	RDTSC = &$$RDTSC
	
	@RDTSC(@start$$)
	'  do stuff
		FOR i = 0 TO 10000000
			x = i
		NEXT i
	@RDTSC(@finish$$)
	
	PRINT finish$$ - start$$ ; " cycles."

  a$ = INLINE$ ("Press Enter to quit >")

END FUNCTION
END PROGRAM