'
'
' ####################
' #####  PROLOG  #####
' ####################
'
' Demo popup window attachs to sides of work area
' Based on PB code by Jules Marchildon
'
VERSION "0.0001"
PROGRAM "stickyedge"
MAKEFILE "pelles.xxx"

IMPORT "xst_s.lib"
IMPORT "xsx_s.lib"
' IMPORT	"xst"   		' standard library	: required by most programs
' IMPORT  "xsx"				' extended std library
IMPORT "gdi32"				' gdi32.dll
IMPORT "user32"				' user32.dll
IMPORT "kernel32"			' kernel32.dll
IMPORT "comctl32"			' comctl32.dll			: common controls library

TYPE TDLGDATA
	DLGTEMPLATE .dltt
	USHORT .menu
	USHORT .class
	STRING * 256 .title
END TYPE


DECLARE FUNCTION Entry ()
DECLARE FUNCTION NewChild (className$, text$, style, x, y, w, h, parent, id, exStyle)
DECLARE FUNCTION NewDialogBox (hWndParent, width, height, dlgProcAddr, style, exstyle, title$, initParam)
DECLARE FUNCTION ShowDIALOG1Proc (hWnd, msg, wParam, lParam)
DECLARE FUNCTION ShowDIALOG1 (hParent)
DECLARE FUNCTION OnWindowPosChanging (lParam)
DECLARE FUNCTION UpdateEditBoxTextNumber (hWnd)
DECLARE FUNCTION UCODE$ (s$)

SHARED gDocked
SHARED RECT grWorkArea
SHARED gStickAt

$$IDD_DIALOG1 = 101
$$IDC_LABEL1 = 1001
$$IDC_TEXTBOX1 = 1002
$$IDC_CHECKBOX1 = 1003
$$IDC_CHECKBOX2 = 1004
$$IDC_CHECKBOX3 = 1005
$$IDC_CHECKBOX4 = 1006
$$IDC_FRAME1 = 1007

$$MAX_RANGE = 80

'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION Entry ()

	SHARED hInst

	hInst = GetModuleHandleA (0)
	InitCommonControls ()

	ShowDIALOG1 ($$HWND_DESKTOP)

END FUNCTION
'
' #########################
' #####  NewChild ()  #####
' #########################
'
FUNCTION NewChild (className$, text$, style, x, y, w, h, parent, id, exStyle)

	SHARED hInst

	style = style | $$WS_CHILD | $$WS_VISIBLE
	RETURN CreateWindowExA (exStyle, &className$, &text$, style, x, y, w, h, parent, id, hInst, 0)

END FUNCTION
'
'
' ####################################
' #####  OnWindowPosChanging ()  #####
' ####################################
'
FUNCTION OnWindowPosChanging (lParam)

	SHARED RECT grWorkArea
	SHARED gDocked
	SHARED gStickAt
	WINDOWPOS wp

	XstCopyMemory (lParam, &wp, SIZE (wp))

	chkLeft = SendMessageA (GetDlgItem (wp.hwnd, $$IDC_CHECKBOX2), $$BM_GETCHECK, 0, 0)
	IF chkLeft = $$BST_CHECKED THEN
		IF wp.x <= grWorkArea.left + gStickAt THEN
			wp.x = grWorkArea.left
			gDocked = $$TRUE
		END IF
	END IF

	chkRight = SendMessageA (GetDlgItem (wp.hwnd, $$IDC_CHECKBOX3), $$BM_GETCHECK, 0, 0)
	IF chkRight = $$BST_CHECKED THEN
		IF wp.x + wp.cx >= grWorkArea.right - gStickAt THEN
			wp.x = grWorkArea.right - wp.cx
			gDocked = $$TRUE
		END IF
	END IF

	chkTop = SendMessageA (GetDlgItem (wp.hwnd, $$IDC_CHECKBOX1), $$BM_GETCHECK, 0, 0)
	IF chkTop = $$BST_CHECKED THEN
		IF wp.y <= grWorkArea.top + gStickAt THEN
			wp.y = grWorkArea.top
			gDocked = $$TRUE
		END IF
	END IF

	chkBottom = SendMessageA (GetDlgItem (wp.hwnd, $$IDC_CHECKBOX4), $$BM_GETCHECK, 0, 0)
	IF chkBottom = $$BST_CHECKED THEN
		IF wp.y + wp.cy >= grWorkArea.bottom - gStickAt THEN
			wp.y = grWorkArea.bottom - wp.cy
			gDocked = $$TRUE
		END IF
	END IF

	IF (gDocked) THEN
		IF wp.x < grWorkArea.left THEN wp.x = grWorkArea.left
		IF wp.x + wp.cx > grWorkArea.right THEN wp.x = grWorkArea.right - wp.cx
		IF wp.y < grWorkArea.top THEN wp.y = grWorkArea.top
		IF wp.y + wp.cy > grWorkArea.bottom THEN wp.y = grWorkArea.bottom - wp.cy
	END IF

	XstCopyMemory (&wp, lParam, SIZE (wp))

END FUNCTION
'
'
' ########################################
' #####  UpdateEditBoxTextNumber ()  #####
' ########################################
'
FUNCTION UpdateEditBoxTextNumber (hWnd)

	SHARED gStickAt

	EditBoxText$ = NULL$ (8)
	GetWindowTextA (hWnd, &EditBoxText$, 8)
	gStickAt = XLONG (EditBoxText$)
	IF gStickAt > $$MAX_RANGE THEN
		gStickAt = $$MAX_RANGE
		t$ = LTRIM$ (STRING$ (gStickAt))
		SetWindowTextA (hWnd, &t$)
		SendMessageA (hWnd, $$EM_SETSEL, 0, -1)
	END IF

END FUNCTION
'
'
' ################################
' #####  ShowDIALOG1Proc ()  #####
' ################################
'
FUNCTION ShowDIALOG1Proc (hWndDlg, msg, wParam, lParam)

	STATIC hWndSaveFocus
	SHARED gDocked
	SHARED RECT grWorkArea
	SHARED gStickAt

	SELECT CASE msg
		CASE $$WM_INITDIALOG

			' create child controls
			#label1 = NewChild ("static", "Stick At...", $$SS_LEFT, 25, 20, 75, 18, hWndDlg, $$IDC_LABEL1, 0)
			style = $$WS_TABSTOP OR $$ES_LEFT OR _
							$$ES_AUTOHSCROLL OR $$ES_NUMBER
			exstyle = $$WS_EX_CLIENTEDGE OR $$WS_EX_LEFT OR _
								$$WS_EX_LTRREADING OR $$WS_EX_RIGHTSCROLLBAR
			#textbox1 = NewChild ("edit", "20", style, 25, 40, 50, 24, hWndDlg, $$IDC_TEXTBOX1, exstyle)

			#group1 = NewChild ("button", "Stick to:", $$BS_GROUPBOX, 115, 6, 160, 85, hWndDlg, $$IDC_FRAME1, 0)

			#checkbox1 = NewChild ("button", "TOP", $$BS_AUTOCHECKBOX, 165, 25, 45, 16, hWndDlg, $$IDC_CHECKBOX1, 0)
			#checkbox2 = NewChild ("button", "LEFT", $$BS_AUTOCHECKBOX, 125, 45, 60, 16, hWndDlg, $$IDC_CHECKBOX2, 0)
			#checkbox3 = NewChild ("button", "RIGHT", $$BS_AUTOCHECKBOX, 200, 45, 60, 16, hWndDlg, $$IDC_CHECKBOX3, 0)
			#checkbox4 = NewChild ("button", "BOTTOM", $$BS_AUTOCHECKBOX, 165, 65, 80, 16, hWndDlg, $$IDC_CHECKBOX4, 0)

			SystemParametersInfoA ($$SPI_GETWORKAREA, 0, &grWorkArea, 0)
			SendMessageA (GetDlgItem (hWndDlg, $$IDC_CHECKBOX1), $$BM_SETCHECK, $$BST_CHECKED, 0)
			SendMessageA (GetDlgItem (hWndDlg, $$IDC_CHECKBOX2), $$BM_SETCHECK, $$BST_CHECKED, 0)
			SendMessageA (GetDlgItem (hWndDlg, $$IDC_CHECKBOX3), $$BM_SETCHECK, $$BST_CHECKED, 0)
			SendMessageA (GetDlgItem (hWndDlg, $$IDC_CHECKBOX4), $$BM_SETCHECK, $$BST_CHECKED, 0)
			UpdateEditBoxTextNumber (#textbox1)
			gDocked = $$FALSE
			SendMessageA (#textbox1, $$EM_SETSEL, 0, -1)
			SetFocus (#textbox1)
			RETURN 1

		CASE $$WM_NCACTIVATE

			IFZ wParam THEN
				' Save control focus
				hWndSaveFocus = GetFocus ()
			ELSE
				IF hWndSaveFocus THEN
					' Restore control focus
					SetFocus (hWndSaveFocus)
					hWndSaveFocus = 0
				END IF
			END IF


		CASE $$WM_COMMAND

			notifyCode = HIWORD (wParam)
			ID = LOWORD (wParam)
			hwndCtl = lParam
			' Process control notifications
			SELECT CASE notifyCode
				CASE $$BN_CLICKED :
					SELECT CASE ID :

						CASE $$IDCANCEL :
							EndDialog (hWndDlg, 0)

					END SELECT

				CASE $$EN_CHANGE
					UpdateEditBoxTextNumber (hwndCtl)

			END SELECT

		CASE $$WM_WINDOWPOSCHANGING
			OnWindowPosChanging (lParam)
			RETURN

	END SELECT
END FUNCTION
'
'
' ############################
' #####  ShowDIALOG1 ()  #####
' ############################
'
FUNCTION ShowDIALOG1 (hParent)

	style = $$WS_POPUP OR _
					$$WS_BORDER OR $$WS_DLGFRAME OR $$WS_CAPTION OR $$WS_SYSMENU OR _
					$$WS_MINIMIZEBOX OR $$WS_MAXIMIZEBOX OR $$WS_CLIPSIBLINGS OR _
					$$WS_VISIBLE OR $$DS_MODALFRAME OR $$DS_3DLOOK OR $$DS_NOFAILCREATE
	exstyle = $$WS_EX_CONTROLPARENT OR $$WS_EX_LEFT OR _
						$$WS_EX_LTRREADING OR $$WS_EX_RIGHTSCROLLBAR

	title$ = "Sticky Edge Demo"

	RETURN NewDialogBox (hParent, 285, 125, &ShowDIALOG1Proc (), style, exstyle, title$, 0)

END FUNCTION
'
'
' #############################
' #####  NewDialogBox ()  #####
' #############################
'
FUNCTION NewDialogBox (hWndParent, width, height, dlgProcAddr, style, exstyle, title$, initParam)

	SHARED hInst
	TDLGDATA tdd										' user defined in this program
	DLGTEMPLATE dltt

	' fill in DLGTEMPLATE struct
	IFZ style THEN
		dltt.style = $$DS_MODALFRAME | $$DS_3DLOOK | $$WS_POPUP | $$WS_CAPTION | $$WS_SYSMENU | $$WS_VISIBLE | $$DS_ABSALIGN | $$DS_SETFONT
	ELSE
		dltt.style = style
	END IF
	dltt.dwExtendedStyle = exstyle
	dltt.cdit = 0										' number of control items in dialog box, this creates an empty dialog box

	bu = GetDialogBaseUnits ()			' get dialog base units
	screenWidth = GetSystemMetrics ($$SM_CXSCREEN)
	screenHeight = GetSystemMetrics ($$SM_CYSCREEN)

	x = (screenWidth - width) / 2		' center dialogbox on screen
	y = (screenHeight - height) / 2

	dialogUnitX = (x * 4) / LOWORD (bu)
	dialogUnitY = (y * 8) / HIWORD (bu)

	dltt.x = dialogUnitX
	dltt.y = dialogUnitY

	dialogUnitWidth = (width * 4) / LOWORD (bu)		' convert width in pixels to dialog units
	dialogUnitHeight = (height * 8) / HIWORD (bu)		' convert height in pixels to dialog units

	dltt.cx = dialogUnitWidth
	dltt.cy = dialogUnitHeight

	' fill in TDLGDATA struct
	tdd.dltt = dltt
	tdd.menu = 0
	tdd.class = 0

	IF title$ THEN
		tdd.title = UCODE$ (title$)
	END IF

	' create dialog box
	RETURN DialogBoxIndirectParamA (hInst, &tdd, hWndParent, dlgProcAddr, initParam)

END FUNCTION
'
'
' #######################
' #####  UCODE$ ()  #####
' #######################
'
FUNCTION UCODE$ (s$)

	textSizeW = LEN (s$) * 2 + 2
	sw$ = NULL$ (textSizeW)
	length = MultiByteToWideChar ($$CP_ACP, 0, &s$, -1, &sw$, textSizeW)
	RETURN sw$
END FUNCTION

END PROGRAM